indexing
	description: "States of Mealy automaton"
	author: ""
	date: "$Date$"
	revision: "$Revision$"

deferred class
	STATE

feature -- Transformation
	set_input (in: BIT_VECTOR) is
			-- Set `current_input' to `in'
		require
			correct_input_size: in /= Void and then in.count = predicate_count
		deferred
		ensure
			input_set: current_input.is_equal(in)
		end


feature -- Access
	actions: BIT_VECTOR is
			-- Value of output function for `current_input'
		deferred
		end

	next_state: INTEGER is
			-- Value of transition function for `current_input'
		deferred
		end

	state_count: INTEGER is
			-- Potential capacity of transition function value space
		deferred
		end

	predicate_count: INTEGER is
			-- Number of predicates in input to output function and transition function
		deferred
		end

	action_count: INTEGER is
			-- Number of actions in output function's values
		deferred
		end

	Initial_state: INTEGER is 1
			-- Initial state index

feature {NONE} -- Implementation
	current_input: BIT_VECTOR is
			-- Input to be used by `actions' and `next_state'
		deferred
		end
invariant
	predicate_count_not_negative: predicate_count >= 0
	action_count_not_negative: action_count >= 0
	state_count_positive: state_count > 0
	correct_current_input_size: current_input.count = predicate_count
	correct_output_size: actions.count = action_count
	next_state_not_too_small: next_state >= 1
	next_state_not_too_large: next_state <= state_count
	initial_state_not_too_small: Initial_state >= 1
	initial_state_not_too_large: Initial_state <= state_count
end
