indexing
	description: "Bit vector individuals: the more ones the better"
	author: ""
	date: "$Date$"
	revision: "$Revision$"

class
	GENETIC_BIT_VECTOR

inherit
	INDIVIDUAL
	undefine
		copy, is_equal
	end

	BIT_VECTOR
	redefine
		make
	end
create
	make

feature -- Initialization
	make(min_index, max_index: INTEGER) is
			-- Call `Precursor' and initialize random generator
		do
			Precursor(min_index, max_index)
			set_fitness_to_default
		end


	randomize is
			-- Make `Current' random
		local
			i: INTEGER
		do
			from
				i := lower
			until
				i > upper
			loop
				r.forth
				put(r.decide(0.5), i)
				i := i + 1
			end
		end

feature -- Access
	mutation_index: REAL

feature -- Status report
	is_compatible_with (other: like Current): BOOLEAN is
			-- Can `Current' and `other' have chilren?
		do
			Result := count = other.count
		end

feature -- Basic operations	
	evaluate is
			-- Calculate fitness
		do
			fitness := occurrences(True) / count
		end

	mutant: like Current is
			-- A mutated version of `Current'
		local
			i: INTEGER
		do
			Result := deep_twin
			r.forth
			if r.decide(mutation_index) then
				r.forth
				i := r.bounded_item(lower, upper)
				Result[i] := not Result [i]
			end
		end

	children (other_parent: like Current) : ARRAY [like Current] is
			-- A pair of children who's parent are `Current' and `other_parent'
		local
			temp: ARRAY[BOOLEAN]
			first_child, second_child: like Current
			cross_point: INTEGER
		do
			first_child := deep_twin
			second_child := other_parent.deep_twin

			r.forth
			cross_point := r.bounded_item(lower + 1, upper)

			temp := first_child.subarray(cross_point, upper)
			first_child.subcopy(second_child, cross_point, upper, cross_point)
			second_child.subcopy(temp, cross_point, upper, cross_point)

			create Result.make(1, 2)
			Result[1] := first_child
			Result[2] := second_child
		end

	set_mutation_index(p: REAL) is
			-- Make `mutation_index' equal to `p'
		do
			mutation_index := p
		end

feature {NONE} -- Implementation
	r: MY_RANDOM is
			-- Random generator for implementation needs
		once
			create Result.make
		end

invariant
	r_exists: r /= Void

end
