class
	ROUTE

create
	make

feature -- Initialization

	make (apt1x1, apt1y1, apt1z1, apt1x2, apt1y2, apt1z2, apt2x1, apt2y1, apt2z1, apt2x2, apt2y2, apt2z2, echelon_altitude, climb_angle, descent_angle, smoothing_radius, landing_altitude, echelon_speed, landing_speed, smooth_time: REAL) is
			-- Initialize `Current'.
		local
			i: INTEGER
			r1: REAL
			v1, v2, v3_1, v3_2: VECTOR
		do
			apt1_1.set_value (apt1x1, apt1y1, apt1z1)
			apt1_2.set_value (apt1x2, apt1y2, apt1z2)
			apt2_1.set_value (apt2x1, apt2y1, apt2z1)
			apt2_2.set_value (apt2x2, apt2y2, apt2z2)
			echelon_alt := echelon_altitude
			climb_ang := climb_angle
			descent_ang := descent_angle
			smoothing_rad := smoothing_radius
			landing_alt := landing_altitude
			echelon_spd := echelon_speed
			landing_spd := landing_speed
			s_time := smooth_time

			state1_point1 := apt1_1
			state1_point2 := apt1_1.mul_on_scalar (0.1) + apt1_2.mul_on_scalar (0.9)
			state2_circle_center := state1_point2 + up_vector.mul_on_scalar (smoothing_rad)
			state2_circle_normal := (apt1_2 - apt1_1).vector_mul_on_vector (up_vector).normal
			state9_point1 := apt2_1.mul_on_scalar (0.9) + apt2_2.mul_on_scalar (0.1)
			state9_point2 := apt2_2
			state8_circle_center := state9_point1 + up_vector.mul_on_scalar (smoothing_rad)
			state8_circle_normal := (apt2_2 - apt2_1).vector_mul_on_vector (up_vector).normal
			--state3_circle_radius state3_circle_center.y=s_p.y state3_ending_point, state3_ending_angle > 0
			state3_starting_point := state2_circle_center + (state1_point2 - state1_point1).normal.mul_on_scalar (smoothing_rad * sin (climb_ang)) -
										up_vector.mul_on_scalar (smoothing_rad * cos (climb_ang))
			state3_ending_point := state3_starting_point
			state7_ending_point := state8_circle_center + (state9_point1 - state9_point2).normal.mul_on_scalar (smoothing_rad * sin (descent_ang)) -
										up_vector.mul_on_scalar (smoothing_rad * cos (descent_ang))
			state7_starting_point := state7_ending_point
			state4_vertical_distance := smoothing_rad * (1 - cos (climb_ang))
			state6_vertical_distance := smoothing_rad * (1 - cos (descent_ang))
			state3_horizontal_distance := (echelon_alt - state4_vertical_distance - state3_starting_point.y_value) / sm.tangent (climb_ang)
			state7_horizontal_distance := (echelon_alt - state6_vertical_distance - state7_ending_point.y_value) / sm.tangent (descent_ang)
			from
				i := 1
			until
				i > 10
			loop
				v1 := state7_starting_point - state3_ending_point
				v1.set_value (v1.x_value, 0, v1.z_value)
				v1 := v1.normal
				v2 := apt1_2 - apt1_1
				v2.set_value (v2.x_value, 0, v2.z_value)
				v2 := v2.normal
				r1 := v1.scalar_mul_on_vector (v2)
				if i < 5 then
					v3_1 := v1 - v2.mul_on_scalar (r1)
					if v3_1.length <= 0 then
						v3_1.set_value (-v2.z_value, 0, v2.x_value)
					end
				end
				state3_ending_angle := sm.arc_cosine (r1)
				if state3_ending_angle = 0 then
					state3_ending_angle := 0.0001
				end
				if (v3_1.scalar_mul_on_vector (v1) < 0) then
					state3_ending_angle := 2 * sm.pi - state3_ending_angle
				end
				state3_circle_radius := state3_horizontal_distance / state3_ending_angle
				state3_circle_center := state3_starting_point + v3_1.normal.mul_on_scalar (state3_circle_radius)
				state3_ending_point := state3_circle_center + v2.mul_on_scalar (state3_circle_radius * sin (state3_ending_angle)) + (state3_starting_point - state3_circle_center).mul_on_scalar (cos (state3_ending_angle)) + up_vector.mul_on_scalar (echelon_alt - state4_vertical_distance - state3_starting_point.y_value)

				v1 := state3_ending_point - state7_starting_point
				v1.set_value (v1.x_value, 0, v1.z_value)
				v1 := v1.normal
				v2 := apt2_1 - apt2_2
				v2.set_value (v2.x_value, 0, v2.z_value)
				v2 := v2.normal
				r1 := v1.scalar_mul_on_vector (v2)
				if i < 5 then
					v3_2 := v1 - v2.mul_on_scalar (r1)
					if v3_2.length <= 0 then
						v3_2.set_value (-v2.z_value, 0, v2.x_value)
					end
				end
				state7_ending_angle := sm.arc_cosine (r1)
				if state7_ending_angle = 0 then
					state7_ending_angle := 0.0001
				end
				if (v3_2.scalar_mul_on_vector (v1) < 0) then
					state7_ending_angle := 2 * sm.pi - state7_ending_angle
				end
				state7_circle_radius := state7_horizontal_distance / state7_ending_angle
				state7_circle_center := state7_ending_point + v3_2.normal.mul_on_scalar (state7_circle_radius)
				state7_starting_point := state7_circle_center + v2.mul_on_scalar (state7_circle_radius * sin (state7_ending_angle)) + (state7_ending_point - state7_circle_center).mul_on_scalar (cos (state7_ending_angle)) + up_vector.mul_on_scalar (echelon_alt - state6_vertical_distance - state7_ending_point.y_value)
				i := i + 1
			end
			v1 := state7_starting_point - state3_ending_point
			v1.set_value (v1.x_value, 0, v1.z_value)
			v1 := v1.normal
			state5_point1 := state3_ending_point + v1.mul_on_scalar (smoothing_rad * sin (climb_ang)) + up_vector.mul_on_scalar (state4_vertical_distance)
			state5_point2 := state7_starting_point - v1.mul_on_scalar (smoothing_rad * sin (descent_ang)) + up_vector.mul_on_scalar (state6_vertical_distance)
			state4_circle_center := state5_point1 - up_vector.mul_on_scalar (smoothing_rad)
			state4_circle_normal := (v1).vector_mul_on_vector (up_vector).normal
			state6_circle_center := state5_point2 - up_vector.mul_on_scalar (smoothing_rad)
			state6_circle_normal := (v1).vector_mul_on_vector (up_vector).normal
			state6_circle_normal.set_value (-state6_circle_normal.x_value, -state6_circle_normal.y_value, -state6_circle_normal.z_value)
			state := 1
		end

feature -- Status report

	v: VECTOR is
			-- opt_speed
		do
			Result := opt_speed
		end

	dev_left: BOOLEAN is
			-- Whether current speed deviates to the left from optimal speed
		do
			Result := up_vector.scalar_mul_on_vector (plane_speed.vector_mul_on_vector (opt_speed)) < 0
		end

	dev_right: BOOLEAN is
			-- Whether current speed deviates to the right from optimal speed
		do
			Result := up_vector.scalar_mul_on_vector (plane_speed.vector_mul_on_vector (opt_speed)) > 0
		end

	dev_down: BOOLEAN is
			-- Whether current speed deviates to the bottom from optimal speed
		do
			Result := plane_speed.normal.y_value < opt_speed.normal.y_value
		end

	dev_up: BOOLEAN is
			-- Whether current speed deviates to the top from optimal speed
		do
			Result := plane_speed.normal.y_value > opt_speed.normal.y_value
		end

	hor_dev: REAL is
			-- Quantity of horizontal deviation
		local
			tv: VECTOR
		do
			tv := opt_speed.normal - plane_speed.normal
			tv.set_value (tv.x_value, 0, tv.z_value)
			Result := tv.length
			if dev_left then
				Result := -Result
			end
		end

	ver_dev: REAL is
			-- Quantity of vertical deviation
		do
			Result := (plane_speed.normal - opt_speed.normal).y_value
		end

	starting: BOOLEAN is
			-- Whether plane is on take-off run
		do
			Result := state = 1
		end

	taking_off: BOOLEAN is
		do
			Result := state = 2
		end

	climbing: BOOLEAN is
		do
			Result := state = 3 or state = 4
		end

	on_echelon: BOOLEAN is
		do
			Result := state = 5
		end

	descending: BOOLEAN is
		do
			Result := state = 6 or state = 7
		end

	landing: BOOLEAN is
		do
			Result := state = 8
		end

	stoping: BOOLEAN is
		do
			Result := state = 9
		end

	arrived: BOOLEAN is
		do
			Result := state = 10
		end

feature -- Status setting

	set_position (x, y, z, vx, vy, vz: REAL) is
			-- Set current plane position and velocity
		do
			plane_pos.set_value (x, y, z)
			plane_speed.set_value (vx, vy, vz)
			inspect state
			when 1 then
				process_state1
			when 2 then
				process_state2
			when 3 then
				process_state3
			when 4 then
				process_state4
			when 5 then
				process_state5
			when 6 then
				process_state6
			when 7 then
				process_state7
			when 8 then
				process_state8
			when 9 then
				process_state9
			when 10 then
				process_state10
			end
			io.put_string ("state: ")
			io.put_integer (state)
			io.put_string (" cur_y ")
			io.put_real (plane_speed.normal.y_value)
			io.put_string (" opt_y ")
			io.put_real (opt_speed.normal.y_value)
			io.put_new_line
		end

feature -- Inapplicable

feature {NONE} -- Implementation
	distance (x1, y1, z1, x2, y2, z2: REAL): REAL is
			-- Distance between two points
		do
			Result := ((x2 - x1) ^ 2 + (y2 - y1) ^ 2 + (z2 - z1) ^ 2) ^ 0.5
		end
	rel_projection_on_line (point, l_1, l_2: VECTOR): REAL is
			-- Relative position of x, y, z on line x1, y1, z1 -> x2, y2, z2
			-- 0 means x1, y1, z1, and 1 means x2, y2, z2
		do
			Result := ((point.x_value - l_1.x_value) * (l_2.x_value - l_1.x_value) + (point.y_value - l_1.y_value) * (l_2.y_value - l_1.y_value) + (point.z_value - l_1.z_value) * (l_2.z_value - l_1.z_value)) / ((l_2.x_value - l_1.x_value) ^ 2 + (l_2.y_value - l_1.y_value) ^ 2 + (l_2.z_value - l_1.z_value) ^ 2)
		end
	projection_on_circle (point, circle_center, circle_normal: VECTOR circle_radius: REAL): VECTOR is
			-- Projects point on circle
		local
			r: REAL
			p: VECTOR
		do
			r := rel_projection_on_line (point, circle_center, circle_center + circle_normal)
			p := circle_center + circle_normal.mul_on_scalar (r)
			Result := circle_center + (point - p).normal.mul_on_scalar (circle_radius)
		end

	up_vector: VECTOR is
			-- Vector up
		once
			Result.set_value (0, 1, 0)
		end

	sm: SINGLE_MATH is
			-- Single math
		once
			create Result
		end

	sin (angle: REAL): REAL is
			-- Sinus
		do
			if angle < 0 then
				Result := -sin (-angle)
			else
				if angle <= sm.pi / 4 then
					Result := sm.sine (angle)
				else
					if angle > sm.pi / 2 then
						Result := sin (sm.pi - angle)
					else
						Result := sm.cosine (sm.pi / 2 - angle)
					end
				end
			end
		end

	cos (angle: REAL): REAL is
			-- Cosinus
		do
			if angle < 0 then
				Result := cos (-angle)
			else
				if angle <= sm.pi / 4 then
					Result := sm.cosine (angle)
				else
					if angle > sm.pi / 2 then
						Result := -cos (sm.pi - angle)
					else
						Result := sm.sine (sm.pi / 2 - angle)
					end
				end
			end
		end

	process_state1 is
			-- Set opt_speed in case of state 1
		local
			rel_pos, dist_left, s_dist, rel_pos_s, a: REAL
			opt_p: VECTOR
		do
			rel_pos := rel_projection_on_line (plane_pos, state1_point1, state1_point2)
			if rel_pos >= 1 then
				state := 2
				process_state2
			else
				dist_left := (1 - rel_pos) * (state1_point2 - state1_point1).length
				s_dist := s_time * plane_speed.length
				if s_dist <= dist_left then
					rel_pos_s := rel_pos + s_dist / (state1_point2 - state1_point1).length
					opt_p := state1_point1.mul_on_scalar (1 - rel_pos_s) + state1_point2.mul_on_scalar (rel_pos_s)
				else
					a := (s_dist - dist_left) / smoothing_rad
					opt_p := state1_point2 + (state1_point2 - state1_point1).normal.mul_on_scalar (smoothing_rad * sin (a)) + up_vector.mul_on_scalar (smoothing_rad * (1 - cos (a)))
				end
				a := 30 * (1 - rel_pos) + echelon_spd * rel_pos
				opt_speed := (opt_p - plane_pos).normal.mul_on_scalar (a)
			end
		end
	process_state2 is
			-- Set opt_speed in case of state 2
		local
			p, opt_p: VECTOR
			a: REAL
		do
			p := projection_on_circle (plane_pos, state2_circle_center, state2_circle_normal, smoothing_rad)
			a := sm.arc_cosine ((state2_circle_center.y_value - p.y_value) / smoothing_rad)
			if a >= climb_ang then
				state := 3
				process_state3
			else
				a := a + s_time * plane_speed.length / smoothing_rad
				if a >= climb_ang then
					a := (a - climb_ang) * smoothing_rad * cos (climb_ang) / state3_circle_radius
					opt_p := state3_circle_center + (state3_starting_point - state3_circle_center).mul_on_scalar (cos (a)) +
								(state1_point2 - state1_point1).normal.mul_on_scalar (state3_circle_radius * sin (a)) +
								up_vector.mul_on_scalar ((state3_ending_point.y_value - state3_starting_point.y_value) * a / state3_ending_angle)
				else
					opt_p := state1_point2 + (state1_point2 - state1_point1).normal.mul_on_scalar (smoothing_rad * sin (a)) + up_vector.mul_on_scalar (smoothing_rad * (1 - cos (a)))
				end
				opt_speed := (opt_p - plane_pos).normal.mul_on_scalar (echelon_spd)
			end
		end
	process_state3 is
			-- Set opt_speed in case of state 3
		local
			p, opt_p: VECTOR
			a: REAL
		do
			p := projection_on_circle (plane_pos, state3_circle_center, up_vector, state3_circle_radius)
			a := sm.arc_cosine ((state3_starting_point - state3_circle_center).normal.scalar_mul_on_vector ((p - state3_circle_center).normal))
			if (a > sm.pi / 2) and ((state1_point2 - state1_point1).scalar_mul_on_vector (p - state3_circle_center) < 0) then
				a := 2 * sm.pi - a
			end
			if a >= state3_ending_angle then
				state := 4
				process_state4
			else
				a := a + s_time * plane_speed.length * cos (climb_ang) / state3_circle_radius
				if a < state3_ending_angle then
					opt_p := state3_circle_center + (state3_starting_point - state3_circle_center).mul_on_scalar (cos (a)) +
								(state1_point2 - state1_point1).normal.mul_on_scalar (state3_circle_radius * sin (a)) +
								up_vector.mul_on_scalar ((state3_ending_point.y_value - state3_starting_point.y_value) * a / state3_ending_angle)
				else
					a := climb_ang - (a - state3_ending_angle) * state3_circle_radius / cos (climb_ang) / smoothing_rad
					opt_p := state5_point1 + (state5_point1 - state5_point2).normal.mul_on_scalar (smoothing_rad * sin (a)) - up_vector.mul_on_scalar (smoothing_rad * (1 - cos (a)))
				end
				opt_speed := (opt_p - plane_pos).normal.mul_on_scalar (echelon_spd)
			end
		end
	process_state4 is
			-- Set opt_speed in case of state 4
		local
			p, opt_p: VECTOR
			a: REAL
		do
			p := projection_on_circle (plane_pos, state4_circle_center, state4_circle_normal, smoothing_rad)
			if (p - state4_circle_center).scalar_mul_on_vector (state5_point2 - state5_point1) > 0 then
				state := 5
				process_state5
			else
				a := sm.arc_cosine ((p.y_value - state4_circle_center.y_value) / smoothing_rad)
				a := a - s_time * plane_speed.length / smoothing_rad
				if a < 0 then
					a := -a * smoothing_rad / (state5_point2 - state5_point1).length
					opt_p := state5_point1.mul_on_scalar (1 - a) + state5_point2.mul_on_scalar (a)
				else
					opt_p := state5_point1 + (state5_point1 - state5_point2).normal.mul_on_scalar (smoothing_rad * sin (a)) - up_vector.mul_on_scalar (smoothing_rad * (1 - cos (a)))
				end
				opt_speed := (opt_p - plane_pos).normal.mul_on_scalar (echelon_spd)
			end
		end
	process_state5 is
			-- Set opt_speed in case of state 5
		local
			rel_pos, dist_left, s_dist, rel_pos_s, a: REAL
			opt_p: VECTOR
		do
			rel_pos := rel_projection_on_line (plane_pos, state5_point1, state5_point2)
			if rel_pos >= 1 then
				state := 6
				process_state6
			else
				dist_left := (1 - rel_pos) * (state5_point2 - state5_point1).length
				s_dist := s_time * plane_speed.length
				if s_dist <= dist_left then
					rel_pos_s := rel_pos + s_dist / (state5_point2 - state5_point1).length
					opt_p := state5_point1.mul_on_scalar (1 - rel_pos_s) + state5_point2.mul_on_scalar (rel_pos_s)
				else
					a := (s_dist - dist_left) / smoothing_rad
					opt_p := state5_point2 + (state5_point2 - state5_point1).normal.mul_on_scalar (smoothing_rad * sin (a)) - up_vector.mul_on_scalar (smoothing_rad * (1 - cos (a)))
				end
				opt_speed := (opt_p - plane_pos).normal.mul_on_scalar (echelon_spd)
			end
		end
	process_state6 is
			-- Set opt_speed in case of state 6
		local
			p, opt_p: VECTOR
			a: REAL
		do
			p := projection_on_circle (plane_pos, state6_circle_center, state6_circle_normal, smoothing_rad)
			a := sm.arc_cosine ((p.y_value - state6_circle_center.y_value) / smoothing_rad)
			if a > descent_ang then
				state := 7
				process_state7
			else
				a := a + s_time * plane_speed.length / smoothing_rad
				if a > descent_ang then
					a := (a - descent_ang) * smoothing_rad * cos (descent_ang) / state7_circle_radius
					opt_p := state7_circle_center + (state7_ending_point - state7_circle_center).mul_on_scalar (cos (state7_ending_angle - a)) +
								(state9_point1 - state9_point2).normal.mul_on_scalar (state7_circle_radius * sin (state7_ending_angle - a)) +
								up_vector.mul_on_scalar ((state7_starting_point.y_value - state7_ending_point.y_value) * (state7_ending_angle - a) / state7_ending_angle)
				else
					opt_p := state5_point2 + (state5_point2 - state5_point1).normal.mul_on_scalar (smoothing_rad * sin (a)) - up_vector.mul_on_scalar (smoothing_rad * (1 - cos (a)))
				end
				opt_speed := (opt_p - plane_pos).normal.mul_on_scalar (echelon_spd)
			end
		end
	process_state7 is
			-- Set opt_speed in case of state 7
		local
			p, opt_p: VECTOR
			a, a1: REAL
		do
			p := projection_on_circle (plane_pos, state7_circle_center, up_vector, state7_circle_radius)
			a := sm.arc_cosine ((state7_ending_point - state7_circle_center).normal.scalar_mul_on_vector ((p - state7_circle_center).normal))
			if (a > sm.pi / 2) and ((state5_point2 - state5_point1).scalar_mul_on_vector (p - state7_circle_center) < 0) then
				a := 2 * sm.pi - a
			end
			a := state7_ending_angle - a
			if (a > state7_ending_angle - sm.pi / 2) and ((state9_point2 - state9_point1).scalar_mul_on_vector (p - state7_circle_center) > 0) then
				state := 8
				process_state8
			else
				a1 := a / state7_ending_angle
				a := a + s_time * plane_speed.length * cos (descent_ang) / state7_circle_radius
				if a <= state7_ending_angle then
					opt_p := state7_circle_center + (state7_ending_point - state7_circle_center).mul_on_scalar (cos (state7_ending_angle - a)) +
								(state9_point1 - state9_point2).normal.mul_on_scalar (state7_circle_radius * sin (state7_ending_angle - a)) +
								up_vector.mul_on_scalar ((state7_starting_point.y_value - state7_ending_point.y_value) * (state7_ending_angle - a) / state7_ending_angle)
				else
					a := descent_ang - (a - state7_ending_angle) / cos (descent_ang) * state7_circle_radius / smoothing_rad
					opt_p := state9_point1 + (state9_point1 - state9_point2).normal.mul_on_scalar (smoothing_rad * sin (a)) + up_vector.mul_on_scalar (smoothing_rad * (1 - cos (a)))
				end
				opt_speed := (opt_p - plane_pos).normal.mul_on_scalar (echelon_spd * (1 - a1) + landing_spd * a1)
			end
		end
	process_state8 is
			-- Set opt_speed in case of state 8
		local
			p, opt_p: VECTOR
			a: REAL
		do
			p := projection_on_circle (plane_pos, state8_circle_center, state8_circle_normal, smoothing_rad)
			if (p - state8_circle_center).scalar_mul_on_vector (state9_point2 - state9_point1) > 0 then
				state := 9
				process_state9
			else
				a := sm.arc_cosine ((state8_circle_center.y_value - p.y_value) / smoothing_rad)
				a := a - s_time * plane_speed.length / smoothing_rad
				if a < 0 then
					a := -a * smoothing_rad / (state9_point2 - state9_point1).length
					opt_p := state9_point1.mul_on_scalar (1 - a) + state9_point2.mul_on_scalar (a)
				else
					opt_p := state9_point1 + (state9_point1 - state9_point2).normal.mul_on_scalar (smoothing_rad * sin (a)) + up_vector.mul_on_scalar (smoothing_rad * (1 - cos (a)))
				end
				opt_speed := (opt_p - plane_pos).normal.mul_on_scalar (landing_spd)
			end
		end
	process_state9 is
			-- Set opt_speed in case of state 9
		local
			opt_p: VECTOR
			a: REAL
		do
			a := rel_projection_on_line (plane_pos, state9_point1, state9_point2)
			if a >= 1 then
				state := 10
				process_state10
			end
			opt_p := state9_point1.mul_on_scalar (1 - a) + state9_point2.mul_on_scalar (a)
			opt_speed := (opt_p - plane_pos).normal.mul_on_scalar (landing_spd * (1 - a))
		end
	process_state10 is
			-- Set opt_speed after arrival
		do
			opt_speed.set_value (0, 0, 0)
		end

	echelon_alt, climb_ang, descent_ang,
	smoothing_rad, landing_alt,
	echelon_spd, landing_spd, s_time,
	state3_circle_radius, state3_ending_angle,
	state7_circle_radius, state7_ending_angle,
	state3_horizontal_distance, state7_horizontal_distance,
	state4_vertical_distance, state6_vertical_distance: REAL
	state: INTEGER
	apt1_1, apt1_2, apt2_1, apt2_2,
	plane_pos,
	plane_speed, opt_speed,
	state1_point1, state1_point2,
	state5_point1, state5_point2,
	state9_point1, state9_point2,
	state2_circle_center, state2_circle_normal,
	state4_circle_center, state4_circle_normal,
	state6_circle_center, state6_circle_normal,
	state8_circle_center, state8_circle_normal,
	state3_starting_point, state3_ending_point, state3_circle_center,
	state7_starting_point, state7_ending_point, state7_circle_center: VECTOR

invariant
	invariant_clause: True -- Your invariant here

end
