indexing
	description: "Objects that ..."
	author: ""
	date: "$Date$"
	revision: "$Revision$"

expanded class
	VECTOR

feature -- Access

feature -- Measurement

feature -- Status report
	x_value: REAL is
			-- X component
		do
			Result := x
		end

	y_value: REAL is
			-- Y component
		do
			Result := y
		end

	z_value: REAL is
			-- Z component
		do
			Result := z
		end

	length: REAL is
			-- Vector length
		do
			Result := (x * x + y * y + z * z) ^ 0.5
		end

feature -- Status setting
	set_value (new_x, new_y, new_z: REAL) is
			-- Set own value to given vector
		do
			x := new_x
			y := new_y
			z := new_z
		end

feature -- Cursor movement

feature -- Element change

feature -- Removal

feature -- Resizing

feature -- Transformation
	infix "+" (other: like Current): like Current is
			-- Summ of two vectors
		do
			Result.set_value (x + other.x_value, y + other.y_value, z + other.z_value)
		end
	infix "-" (other: like Current): like Current is
			-- Subtract one vector from another
		do
			Result.set_value (x - other.x_value, y - other.y_value, z - other.z_value)
		end
	mul_on_scalar (s: REAL): like Current is
			-- Multiplication of Current on s
		do
			Result.set_value (x * s, y * s, z * s)
		end
	scalar_mul_on_vector (other: like Current): REAL is
			-- Scalar multiplication of two vectors
		do
			Result := x * other.x_value + y * other.y_value + z * other.z_value
		end
	vector_mul_on_vector (other: like Current): like Current is
			-- Vector multiplication of two vectors
		do
			Result.set_value (y * other.z_value - z * other.y_value, z * other.x_value - x * other.z_value, x * other.y_value - y * other.x_value)
		end

	normal: like Current is
			-- Normalized Current
		local
			l: REAL
		do
			l := (x * x + y * y + z * z) ^ 0.5
			if l = 0 then
				l := 1
			end
			Result.set_value (x / l, y / l, z / l)
		end

feature -- Conversion

feature -- Duplication

feature -- Miscellaneous

feature -- Basic operations

feature -- Obsolete

feature -- Inapplicable

feature {NONE} -- Implementation
	x, y, z: REAL

invariant
	invariant_clause: True -- Your invariant here

end
